<?php	
	Loader::block('library_file');
	defined('C5_EXECUTE') or die("Access Denied.");	
	class TomoacSlidingBoxesBlockController extends BlockController {

		protected $btInterfaceWidth = 400;
		protected $btInterfaceHeight = 560;
		protected $btTable = 'btTomoacSlidingBoxes';
		protected $btCacheBlockRecord = true;
		protected $btCacheBlockOutput = true;
		protected $btCacheBlockOutputOnPost = true;
		protected $btCacheBlockOutputForRegisteredUsers = true;
		protected $btWrapperClass = 'ccm-ui';
		protected $btExportFileColumns = array('fID','fID2');

		/** 
		 * Used for localization. If we want to localize the name/description we have to include this
		 */
		public function getBlockTypeDescription() {
			return t("Tomoac Sliding Boxes Block.");
		}
		
		public function getBlockTypeName() {
			return t("Tomoac Sliding Boxes");
		}		
		
		public function getJavaScriptStrings() {
			return array(
				'image-required' => t('You must select an image.')
			);
		}

		function getFileID() {return $this->fID;}
/*	
		function getFileOnstateID() {return $this->fOnstateID;}
		function getFileOnstateObject() {
			if ($this->fOnstateID > 0) {
				return File::getByID($this->fOnstateID);
			}
		}
*/
		function getFileObject() {
			return File::getByID($this->fID);
		}		
		function getAltText() {return $this->altText;}
		function getExternalLink() {return $this->externalLink;}
		function getInternalLinkCID() {return $this->internalLinkCID;}
		function getLinkURL() {
			if (!empty($this->externalLink)) {
				return $this->externalLink;
			} else if (!empty($this->internalLinkCID)) {
				$linkToC = Page::getByID($this->internalLinkCID);
				return (empty($linkToC) || $linkToC->error) ? '' : Loader::helper('navigation')->getLinkToCollection($linkToC);
			} else {
				return '';
			}
		}

		function getFileID2() {return $this->fID2;}
		function getFileObject2() {
			return File::getByID($this->fID2);
		}		
		function getAltText2() {return $this->altText2;}
		function getExternalLink2() {return $this->externalLink2;}
		function getInternalLinkCID2() {return $this->internalLinkCID2;}
		function getLinkURL2() {
			if (!empty($this->externalLink2)) {
				return $this->externalLink2;
			} else if (!empty($this->internalLinkCID2)) {
				$linkToC = Page::getByID($this->internalLinkCID2);
				return (empty($linkToC) || $linkToC->error) ? '' : Loader::helper('navigation')->getLinkToCollection($linkToC);
			} else {
				return '';
			}
		}
		
		public function save($args) {

			$args['fOnstateID'] = ($args['fOnstateID'] != '') ? $args['fOnstateID'] : 0;
			$args['fID'] = ($args['fID'] != '') ? $args['fID'] : 0;
			$args['maxWidth'] = (intval($args['maxWidth']) > 0) ? intval($args['maxWidth']) : 0;
			$args['maxHeight'] = (intval($args['maxHeight']) > 0) ? intval($args['maxHeight']) : 0;
			switch (intval($args['linkType'])) {
				case 1:
					$args['externalLink'] = '';
					break;
				case 2:
					$args['internalLinkCID'] = 0;
					break;
				default:
					$args['externalLink'] = '';
					$args['internalLinkCID'] = 0;
					break;
			}
			unset($args['linkType']); //this doesn't get saved to the database (it's only for UI usage)

			$args['fOnstateID2'] = ($args['fOnstateID2'] != '') ? $args['fOnstateID2'] : 0;
			$args['fID2'] = ($args['fID2'] != '') ? $args['fID2'] : 0;
			$args['maxWidth2'] = (intval($args['maxWidth2']) > 0) ? intval($args['maxWidth2']) : 0;
			$args['maxHeight2'] = (intval($args['maxHeight2']) > 0) ? intval($args['maxHeight2']) : 0;
			switch (intval($args['linkType2'])) {
				case 1:
					$args['externalLink2'] = '';
					break;
				case 2:
					$args['internalLinkCID2'] = 0;
					break;
				default:
					$args['externalLink2'] = '';
					$args['internalLinkCID2'] = 0;
					break;
			}
			unset($args['linkType2']); //this doesn't get saved to the database (it's only for UI usage)

			$args['wrapAround'] = intval($args['wrapAround']);
			$args['firstBlock'] = intval($args['firstBlock']);
			parent::save($args);
		}

		function getContentAndGenerate($align = false, $style = false, $id = null) {
			$c = Page::getCurrentPage();
			$bID = $this->bID;
			
			// ---- base images ---- //
			$f = $this->getFileObject();
			$fullPath = $f->getPath();
			$size = @getimagesize($fullPath);
			if (empty($size)) {
				echo t( 'Image Not Found. ');
			    return '';
			}
			if ($this->maxWidth == $size[0] && $this->maxHeight == $size[1]) {
				$sizeStr = $size[3];
			} else if (!$this->forceImageToMatchDimensions && ($this->maxWidth > 0 || $this->maxHeight > 0)) { 
				$mw = $this->maxWidth > 0 ? $this->maxWidth : $size[0];
				$mh = $this->maxHeight > 0 ? $this->maxHeight : $size[1];
				$sizeStr = ' width="' . $mw . '" height="' . $mh . '"';
			} else {
				$sizeStr = $size[3];
			}
			$relPath = $f->getRelativePath();

			// ---- thumnail ---- //
			$f = $this->getFileObject2();
			$fullPath = $f->getPath();
			$size = @getimagesize($fullPath);
			if (empty($size)) {
				echo t( 'Image Not Found. ');
			    return '';
			}	
			if ($this->maxWidth2 == $size[0] && $this->maxHeight2 == $size[1]) {
				$sizeStr2 = $size[3];
			} else if (!$this->forceImageToMatchDimensions2 && ($this->maxWidth2 > 0 || $this->maxHeight2 > 0)) { 
				$mw = $this->maxWidth2 > 0 ? $this->maxWidth2 : $size[0];
				$mh = $this->maxHeight2 > 0 ? $this->maxHeight2 : $size[1];
				$sizeStr2 = ' width="' . $mw . '" height="' . $mh . '"';
			} else {
				$sizeStr2 = $size[3];
			}
			$relPathHover2 = $f->getRelativePath();

			$dirrel = DIR_REL.'/packages/tomoac_lightbox/blocks/tomoac_lightbox';
//			error_log("dirrel=$dirrel",0);

			if($this->firstBlock) {
?>
		<style type="text/css">
		
			*{ padding:0px; margin:0px; }
			body{ background:#D5DEE7; }
			a{ color:#C8DCE5; }
			h3{ margin: 10px 10px 0 10px; color:#FFF; font:18pt Arial, sans-serif; letter-spacing:-1px; font-weight: bold;  }
			
			.boxgrid{ 
				width: 325px; 
				height: 260px; 
				margin:10px; 
				float:left; 
				background:#161613; 
				border: solid 2px #8399AF; 
				overflow: hidden; 
				position: relative; 
			}
				.boxgrid img{ 
					position: absolute; 
					top: 0; 
					left: 0; 
					border: 0; 
				}
				.boxgrid p{ 
					padding: 0 10px; 
					color:#afafaf; 
					font-weight:bold; 
					font:10pt "Lucida Grande", Arial, sans-serif; 
				}
				
			.boxcaption{ 
				float: left; 
				position: absolute; 
				background: #000; 
				height: 100px; 
				width: 100%; 
				opacity: .8; 
				/* For IE 5-7 */
				filter: progid:DXImageTransform.Microsoft.Alpha(Opacity=80);
				/* For IE 8 */
				-MS-filter: "progid:DXImageTransform.Microsoft.Alpha(Opacity=80)";
 			}
 				.captionfull .boxcaption {
 					top: 260;
 					left: 0;
 				}
 				.caption .boxcaption {
 					top: 220;
 					left: 0;
 				}
				
		</style>

		<script type="text/javascript">
			$(document).ready(function(){
				//To switch directions up/down and left/right just place a "-" in front of the top/left attribute
				//Vertical Sliding
				$('.boxgrid.slidedown').hover(function(){
					$(".cover", this).stop().animate({top:'-260px'},{queue:false,duration:300});
				}, function() {
					$(".cover", this).stop().animate({top:'0px'},{queue:false,duration:300});
				});
				//Horizontal Sliding
				$('.boxgrid.slideright').hover(function(){
					$(".cover", this).stop().animate({left:'325px'},{queue:false,duration:300});
				}, function() {
					$(".cover", this).stop().animate({left:'0px'},{queue:false,duration:300});
				});
				//Diagnal Sliding
				$('.boxgrid.thecombo').hover(function(){
					$(".cover", this).stop().animate({top:'260px', left:'325px'},{queue:false,duration:300});
				}, function() {
					$(".cover", this).stop().animate({top:'0px', left:'0px'},{queue:false,duration:300});
				});
				//Partial Sliding (Only show some of background)
				$('.boxgrid.peek').hover(function(){
					$(".cover", this).stop().animate({top:'90px'},{queue:false,duration:160});
				}, function() {
					$(".cover", this).stop().animate({top:'0px'},{queue:false,duration:160});
				});
				//Full Caption Sliding (Hidden to Visible)
				$('.boxgrid.captionfull').hover(function(){
					$(".cover", this).stop().animate({top:'160px'},{queue:false,duration:160});
				}, function() {
					$(".cover", this).stop().animate({top:'260px'},{queue:false,duration:160});
				});
				//Caption Sliding (Partially Hidden to Visible)
				$('.boxgrid.caption').hover(function(){
					$(".cover", this).stop().animate({top:'160px'},{queue:false,duration:160});
				}, function() {
					$(".cover", this).stop().animate({top:'220px'},{queue:false,duration:160});
				});
			});
		</script>
<?php
			}
			echo "\n";
			if($this->wrapAround == 1)
				echo '<div style="margin-right: 8px; float: left;">'."\n";
			if($this->wrapAround == 2)
				echo '<div style="margin-right: 8px; float: right;">'."\n";

			switch ($this->slideType) {

			case 'captionfull':
				echo '<div class="boxgrid captionfull">';
				echo '  <img src="'.$relPath.'" alt="">';
				echo '  <div style="top: 260px;" class="cover boxcaption">';
				echo '    <h3>'.$this->Title.'</h3>';
				echo '    <p>'.$this->subTitle.'<br><a href="'.$this->linkURL.'" target="_BLANK">'.$this->linkText.'</a></p>';
				echo '  </div>';
				echo '</div>';
				break;

			case 'caption':
				echo '<div class="boxgrid caption">';
				echo '  <img src="'.$relPath.'" alt="">';
				echo '  <div style="top: 220px;" class="cover boxcaption">';
				echo '    <h3>'.$this->Title.'</h3>';
				echo '    <p>'.$this->subTitle.'<br><a href="'.$this->linkURL.'" target="_BLANK">'.$this->linkText.'</a></p>';
				echo '  </div>';
				echo '</div>';
				break;

			case 'slideright':
				echo '<div class="boxgrid slideright">';
				echo '  <img style="left: 0px;" class="cover" src="'.$relPath.'" alt="">';
				echo '  <h3>'.$this->Title.'</h3>';
				echo '  <p>'.$this->subTitle.'<br><a href="'.$this->linkURL.'" target="_BLANK">'.$this->linkText.'</a></p>';
				echo '  </div>';
				echo '</div>';
				break;
	
			case 'thecombo':
				echo '<div class="boxgrid thecombo">';
				echo '  <img style="top: 0px; left: 0px;" class="cover" src="'.$relPath.'" alt="">';
				echo '  <h3>'.$this->Title.'</h3>';
				echo '  <p>'.$this->subTitle.'<br><a href="'.$this->linkURL.'" target="_BLANK">'.$this->linkText.'</a></p>';
				echo '  </div>';
				echo '</div>';
				break;

			case 'slidedown':
				echo '<div class="boxgrid slidedown">';
				echo '  <img style="top: 0px;" class="cover" src="'.$relPath.'" alt="">';
				echo '  <h3>'.$this->Title.'</h3>';
				echo '  <p>'.$this->subTitle.'<br><a href="'.$this->linkURL.'" target="_BLANK">'.$this->linkText.'</a></p>';
				echo '</div>';
				break;

			case 'peek':
				echo '<div class="boxgrid peek">';
				echo '  <a href="'.$this->linkURL.'" target="_BLANK">';
				echo '  <img src="'.$relPath.'" alt="">';
				echo '  </a>';
				echo '  <a href="'.$this->linkURL.'" target="_BLANK"><img style="top: 0px;" class="cover" src="'.$relPathHover2.'" alt=""></a>';
				echo '</div>';
				break;
			}
			if($this->wrapAround > 0)
				echo '</div>'."\n";

			return $img;
		}
	}
?>
